const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const pulseService = require('./pulse.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new pulse
 * @param {Object} req.body - The pulse data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created pulse
 */
function create(req, res, next) {
    pulseService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all pulses
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of pulses
 */
function getAll(req, res, next) {
    pulseService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of pulse objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of pulse objects
 */
function option(req, res, next) {
    pulseService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of pulses matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of pulses
 */
function count(req, res, next) {
    pulseService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing pulse
 * @param {number} req.params.id - The pulse ID to be updated
 * @param {Object} req.body - The pulse data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated pulse
 */
function update(req, res, next) {
    pulseService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Enable or disable a pulse
 * @param {number} req.params.id - The pulse ID to be enabled/disabled
 * @param {Object} req.body - The pulse data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the pulse
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
    pulseService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a pulse
 * @param {number} req.params.id - The pulse ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    pulseService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
